library pz3d_gldrv;

uses
  SysUtils, Classes, a3d, Forms, Windows, OpenGL, Dialogs, Messages, FormGL;
const TextInfo:TTextInfo = (InterfaceVersion:1;FullDriverName:'OpenGL driver for  by Mish!';ShortDriverName:'OpenGL';SysDriverID:'MISHOPENGL';DriverVersion:'0.01 beta');
      fNearZ = 10;
      fFarZ = 100;
type
  TGL3DFrame = class(TAbstract3DFrame)
   private
      FMat:array of TGLMaterial;
      px,py,pz:Single;// position
      rx,ry,rz,incr,trx,tryy,trz:Single; // rotation
      FVertex:Array of TVertex;
      FNormals:Array of TNormal;
      FFaces:array of array of TFVN;
      procedure Process;override;
   public
     constructor Create(Parent:TAbstract3DFrame);override;
     function AddVertex(Vertex:TVector):cardinal;overload;override;
     function AddVertex(x,y,z:Single):cardinal;overload;override;
     function AddNormal(Normal:TVector):cardinal;overload;override;
     function AddNormal(x,y,z:Single):cardinal;overload;override;
     function AddMaterial(Material:TGLMaterial):cardinal;overload;override;
     function AddMaterial(Ambient,Diffuse,Specular:TA3DColor;Emission,Shininess:single):cardinal;overload;override;
     procedure ReplaceMaterial(ID:integer;Material:TGLMaterial);overload;override;
     procedure ReplaceMaterial(ID:integer;Ambient,Diffuse,Specular:TA3DColor;Emission,Shininess:single);overload;override;
     procedure AddFace(FVN:array of TFVN);override;

     procedure SetRotation(x,y,z,increment:Single);override;
     procedure Rotate(x,y,z:Single);override;
//     procedure SetTexture(Texture:TGLTexture;DestroyOld:Boolean = true);override;
     procedure SetPosition(x,y,z:Single);override;
     procedure Move(dx,dy,dz:Single);override;

     function GetPolygonCount:cardinal;override;
  end;

  TGL3D = class (TAbstract3D)
    private
      oldproc:TNotifyEvent;
      Palette:HPalette;
      parent:TForm;
      FDepthBits:byte;
      DC:HDC;
      hrc:HGLRC;
      procedure SetDCPixelFormat;
      procedure q(Sender: TObject);
    public
      constructor Create(Form:TForm;Rect:TRect);override;
      destructor Destroy;override;
      property CanDraw;
      property Renderer;
      property BackColor;
      property ColorBits;
      property Width;
      property Height;
      property Ugol;
      property ViewRect;
      property Scene;
      procedure Initialize;override;
      procedure Finalize;override;
      procedure Render;override;
//      procedure ShowSetupWindow;override;
  end;

constructor TGL3D.Create(Form:TForm;Rect:TRect);
var q:pchar;
begin
  inherited Create(Form,Rect);
  if not Assigned(Form) then raise Exception.Create('  !');
  Parent:=Form;
  FScene:=TGL3DFrame.Create(nil);
  FColorBits:=16;
  FDepthBits:=16;
  DC := GetDC(Form.Handle);
//  DC:=Canvas.Handle;
  SetDCPixelFormat;
  hrc := wglCreateContext(DC);
  wglMakeCurrent(DC, hrc);
//  glEnable( GL_ALPHA_TEST );
//  glEnable( GL_LIGHTING );
  glEnable( GL_DEPTH_TEST );
  glEnable( GL_NORMALIZE );
  glEnable(GL_LIGHT0);
  q:=glGetString(GL_RENDERER);
  if assigned(q) then Frenderer:=q else FRenderer:='Unknown';
  FCanDraw:=True;
end;

destructor TGL3D.Destroy;
begin
 wglMakeCurrent(0, 0);
 wglDeleteContext(hrc);
 ReleaseDC(Parent.Handle, DC);
 inherited;
end;

procedure Tgl3d.Q(Sender: TObject);
var w,h:integer;
begin
  FcanDraw:=False;
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  w:=FRect.Right-FRect.Left;
  h:=FRect.Bottom-FRect.Top;
  gluPerspective(FUgol, w/h, fNearZ, fFarZ);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  glViewport(FRect.Left,FRect.Top,FRect.Right,FRect.Bottom);
  gluLookAt(FCamX,FCamY,FCamZ,FTgX,FTgY,FTgZ,FUpX,FUpY,FUpZ);
  glClearColor(FBKColor.r,FBKColor.g,FBKColor.b,FBKColor.a);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  inherited Render;
  glFinish;
  if Assigned(OldProc) then oldproc(Sender);
  FcanDraw:=True;
end;

procedure TGL3D.Initialize;
begin
 if Assigned(parent.OnPaint) then OldProc:=parent.OnPaint;
 parent.OnPaint:=q;
end;

procedure TGL3D.Finalize;
begin end;

procedure TGL3D.Render;
begin
  SendMessage(Parent.Handle,WM_PAINT,0,0);;
end;

procedure TGL3D.SetDCPixelFormat;
var
 hHeap: THandle;
 nColors, i: Integer;
 lpPalette: PLogPalette;
 byRedMask, byGreenMask, byBlueMask: Byte;
 nPixelFormat: Integer;
 pfd: TPixelFormatDescriptor;
begin
 FillChar(pfd, SizeOf(pfd), 0);

 with pfd do begin
   nSize     := sizeof(pfd);
   nVersion  := 1;
   dwFlags   := PFD_DRAW_TO_WINDOW or
                PFD_SUPPORT_OPENGL or
                PFD_DOUBLEBUFFER;
   iPixelType:= PFD_TYPE_RGBA;
   cColorBits:= FColorBits;
{   cRedBits:=8;
   cRedShift:=0;
   cGreenBits:=8;
   cGreenShift:=0;
   cBlueBits:=8;
   cBlueShift:=0; }
   cAccumBits:=16;
   cAccumRedBits:=5;
   cAccumGreenBits:=5;
   cAccumBlueBits:=5;
   cAccumAlphaBits:=1;
   cStencilBits:=16;
   cDepthBits:= FDepthBits;
   iLayerType:= PFD_MAIN_PLANE;
 end;
 nPixelFormat := ChoosePixelFormat(DC, @pfd);
 SetPixelFormat(DC, nPixelFormat, @pfd);

 DescribePixelFormat(DC, nPixelFormat, sizeof(TPixelFormatDescriptor), pfd);
 if ((pfd.dwFlags and PFD_GENERIC_FORMAT) = 0) then
 if ((pfd.dwFlags and PFD_GENERIC_ACCELERATED) = 0) then
     ShowMessage('!!!');

 if ((pfd.dwFlags and PFD_NEED_PALETTE) <> 0) then begin
   nColors   := 1 shl pfd.cColorBits;
   hHeap     := GetProcessHeap;
   lpPalette := HeapAlloc(hHeap, 0, sizeof(TLogPalette) + (nColors * sizeof(TPaletteEntry)));

   lpPalette^.palVersion := $300;
   lpPalette^.palNumEntries := nColors;

   byRedMask   := (1 shl pfd.cRedBits) - 1;
   byGreenMask := (1 shl pfd.cGreenBits) - 1;
   byBlueMask  := (1 shl pfd.cBlueBits) - 1;

   for i := 0 to nColors - 1 do begin
     lpPalette^.palPalEntry[i].peRed   := (((i shr pfd.cRedShift)   and byRedMask)   * 255) DIV byRedMask;
     lpPalette^.palPalEntry[i].peGreen := (((i shr pfd.cGreenShift) and byGreenMask) * 255) DIV byGreenMask;
     lpPalette^.palPalEntry[i].peBlue  := (((i shr pfd.cBlueShift)  and byBlueMask)  * 255) DIV byBlueMask;
     lpPalette^.palPalEntry[i].peFlags := 0;
   end;

   Palette := CreatePalette(lpPalette^);
   HeapFree(hHeap, 0, lpPalette);

   if (Palette <> 0) then begin
     SelectPalette(DC, Palette, False);
     RealizePalette(DC);
   end;
 end;
end;

function GetInitData:PTextInfo;
begin
  Result:=Addr(TextInfo);
end;

constructor TGL3DFrame.Create(Parent:TAbstract3DFrame);
begin
  inherited Create(Parent);
end;

function TGL3DFrame.AddVertex(Vertex:TVector):cardinal;
var q:integer;
begin
  q:=High(FVertex);
  Inc(q);
  SetLength(FVertex,q+1);
  FVertex[q]:=Vertex;
  Result:=q;
end;

function TGL3DFrame.AddVertex(x,y,z:Single):cardinal;
var q:integer;
begin
  q:=High(FVertex);
  Inc(q);
  SetLength(FVertex,q+1);
  FVertex[q].x:=x;
  FVertex[q].y:=y;
  FVertex[q].z:=z;
  Result:=q;
end;

function TGL3DFrame.AddNormal(Normal:TVector):cardinal;
var q:integer;
begin
  q:=High(FNormals);
  Inc(q);
  SetLength(FNormals,q+1);
  FNormals[q]:=Normal;
  Result:=q;
end;

function TGL3DFrame.AddNormal(x,y,z:Single):cardinal;
var q:integer;
begin
  q:=High(FNormals);
  Inc(q);
  SetLength(FNormals,q+1);
  FNormals[q].x:=x;
  FNormals[q].y:=y;
  FNormals[q].z:=z;
  Result:=q;
end;

function TGL3DFrame.AddMaterial(Material:TGLMaterial):cardinal;
var q:integer;
begin
  q:=High(FMat);
  Inc(q);
  SetLength(FMat,q+1);
  FMat[q]:=Material;
  Result:=q;
end;

function TGL3DFrame.AddMaterial(Ambient,Diffuse,Specular:TA3DColor;Emission,Shininess:single):cardinal;
var q:integer;
begin
  q:=High(FMat);
  Inc(q);
  SetLength(FMat,q+1);
  FMat[q].Ambient:=Ambient;
  FMat[q].Diffuse:=Diffuse;
  FMat[q].Specular:=Specular;
  FMat[q].Emission:=Emission;
  FMat[q].Shininess:=Shininess;
  Result:=q;
end;

procedure TGL3DFrame.ReplaceMaterial(ID:integer;Material:TGLMaterial);
begin

end;

procedure TGL3DFrame.ReplaceMaterial(ID:integer;Ambient,Diffuse,Specular:TA3DColor;Emission,Shininess:single);
begin

end;

procedure TGL3DFrame.AddFace(FVN:array of TFVN);
var i,n,m:integer;
begin
  n:=High(FFaces);
  inc(n);
  m:=0;
  for i:=0 to High(FFaces) do if High(FFaces[i])>m then m:=High(FFaces[i]);
  m:=max(High(FVN)+1,m);
  SetLength(FFaces,n+1,m);
  for i:=0 to High(FVN) do
   begin
    FFaces[n,i].Vertex:=FVN[i].Vertex;
    FFaces[n,i].Normal:=FVN[i].Normal;
    FFaces[n,i].TexX:=FVN[i].TexX;
    FFaces[n,i].TexY:=FVN[i].TexY;
   end;
end;

function TGL3DFrame.GetPolygonCount:cardinal;
begin
  Result:=High(FFaces);
end;

procedure TGL3DFrame.Process;
var i,j:integer;
    q:cardinal;
begin
   glPushAttrib(GL_ALL_ATTRIB_BITS);
   glPushMatrix;
   {}
   glTranslatef(px,py,pz);
//   glScalef(fsx,fsy,fsz);
   {}
   trx:=trx+rx*incr;
   tryy:=tryy+ry*incr;
   trz:=trz+rz*incr;
   if trx>360 then trx:=trx-360;
   if tryy>360 then tryy:=tryy-360;
   if trz>360 then trz:=trz-360;
   if trx<0 then trx:=trx+360;
   if tryy<0 then tryy:=tryy+360;
   if trz<0 then trz:=trz+360;
   if trx<>0 then glRotateF(trx,1.0,0,0);
   if tryy<>0 then glRotateF(tryy,0,1.0,0);
   if trz<>0 then glRotateF(trz,0,0,1.0);

  glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
  glHint(GL_LINE_SMOOTH_HINT,GL_FASTEST);
  glHint(GL_POINT_SMOOTH_HINT,GL_FASTEST);
  glHint(GL_POLYGON_SMOOTH_HINT,GL_FASTEST);

  inherited Process;

  for i:=0 to High(FFaces) do
   begin
     glBegin(GL_POLYGON);
     for j:=0 to high(FFaces[i]) do
      begin
       if (j=0) or ((j<>0)and(FFaces[i,j-1].Material<>FFaces[i,j].Material)) then begin
         q:=FFaces[i,j].Material;
         glMaterialf(GL_FRONT,GL_DIFFUSE,FMat[q].Diffuse.d[0]);
         glMaterialf(GL_FRONT,GL_AMBIENT,FMat[q].Ambient.d[0]);
         glMaterialf(GL_FRONT,GL_SPECULAR,FMat[q].Specular.d[0]);
         glMaterialf(GL_FRONT,GL_SHININESS,FMat[q].Shininess);
         glMaterialf(GL_FRONT,GL_EMISSION,FMat[q].Emission);
       end;
       if (j=0) or ((j<>0)and(FFaces[i,j-1].Normal<>FFaces[i,j].Normal)) then
       glNormal3f(FNormals[FFaces[i,j].Normal].x,
                  FNormals[FFaces[i,j].Normal].y,
                  FNormals[FFaces[i,j].Normal].z);
//       if Assigned(FTEx) then glTexCoord2d(FFaces[i,j].TexX,FFaces[i,j].TexY);
       glVertex3f(FVertex[FFaces[i,j].Vertex].x,
                  FVertex[FFaces[i,j].Vertex].y,
                  FVertex[FFaces[i,j].Vertex].z);
      end;
     glEnd;
   end;

  glPopMatrix;
  glPopAttrib;
end;

procedure TGL3DFrame.SetRotation(x,y,z,increment:Single);
begin
  rx:=x;ry:=y;rz:=z;incr:=increment;
end;

procedure TGL3DFrame.Rotate(x,y,z:Single);
begin
  rx:=x;ry:=y;rz:=z;incr:=0;
end;

//procedure TGL3DFrame.SetTexture(Texture:TGLTexture;DestroyOld:Boolean = true);override;
procedure TGL3DFrame.SetPosition(x,y,z:Single);
begin
  px:=x;py:=y;pz:=z;
end;

procedure TGL3DFrame.Move(dx,dy,dz:Single);
begin
  px:=px+dx;
  py:=py+dy;
  pz:=pz+dz;
end;

function CreateMain(const Form:Pointer;const Rect:PRect):Pointer;
begin
  Result:=TGL3D.Create(TForm(form),Rect^);
end;

function CreateFrame(const Parent:Pointer):Pointer;
begin
  Result:=TGL3DFrame.Create(TAbstract3DFrame(Parent));
end;

exports GetInitData, CreateMain, CreateFrame;
begin
end.
