unit D3DRMUtils;

interface
 Uses DirectX;

type TV = array of array of single;

procedure CreateSphere(x,y,z,Radius:Single;SegX,SegY:Integer;MB:IDirect3DRMMeshBuilder);
procedure CreateCone(xOsn,yOsn,zOsn,height,Radius:single;segm:integer;MeshBuilder:IDirect3DRMMeshBuilder);
procedure MoveVertex(dx,dy,dz:single;Mesh:IDirect3DRMMeshBuilder);
function GetNormal(vertex:TV;v1,v2,v3:integer):D3DVector;
procedure MoveFrame(dx,dy,dz:single;Frame:IDirect3DRMFrame);

implementation

procedure CreateSphere(x,y,z,Radius:Single;SegX,SegY:Integer;MB:IDirect3DRMMeshBuilder);
var v,n:array of array of integer;
    uX,uY,duX,duY:real;
    i,j:integer;
    a:IDirect3DRMFace;
begin
  SetLength(v,SegX+1,SegY+1);
  SetLength(n,SegX+1,SegY+1);
  uX:=0;uY:=0;
  duX:=2*pi/(SegX-1);
  duY:=pi/(SegY-1);
  for i:=1 to SegX do
   begin
    for j:=1 to SegY do
     begin
       v[i,j]:=mb.AddVertex(cos(uX)*Radius*sin(uY),sin(uX)*sin(uY)*Radius,cos(uY)*Radius);
       n[i,j]:=mb.AddNormal(cos(uX)*Radius*sin(uY),sin(uX)*sin(uY)*Radius,cos(uY)*Radius);
       uY:=uY+duY;
     end;
    uX:=uX+duX;
    uY:=0;
   end;
   for j:=1 to SegY-1 do
  for i:=1 to SegX-1 do
    begin
      mb.CreateFace(a);
      a.AddVertexAndNormalIndexed(v[i,j],n[i,j]);
      a.AddVertexAndNormalIndexed(v[i,(j+1)],n[i,(j+1)]);
      a.AddVertexAndNormalIndexed(v[(i+1),(j+1)],n[(i+1),(j+1)]);
      a.AddVertexAndNormalIndexed(v[(i+1),j],n[(i+1),j]);
      mb.AddFace(a);
    end;
end;

procedure CreateCone(xOsn,yOsn,zOsn,height,Radius:single;segm:integer;MeshBuilder:IDirect3DRMMeshBuilder);
var u,du:double;
    v,n,n1:array of integer;
    i:integer;
    z:IDirect3DRMFace;
begin
  SetLength(v,Segm+1);
  SetLength(n,Segm+1);
  SetLength(n1,Segm+1);
  u:=0;
  du:=2*pi/(segm-1);
  v[0]:=MeshBuilder.AddVertex(xOsn,yOsn,zOsn+height);
  n[0]:=MeshBuilder.AddNormal(0,0,-1);
  v[Segm+1]:=MeshBuilder.AddVertex(xOsn,yOsn,zOsn);
  for i:=1 to Segm do
   begin
     v[i]:=MeshBuilder.AddVertex(cos(u)*Radius+xOsn,sin(u)*Radius+yOsn, zOsn);
     n[i]:=MeshBuilder.AddNormal(cos(u),sin(u), 1);
     n1[i]:=MeshBuilder.AddNormal((cos(u)+cos(u+du))/2,(sin(u)+sin(u+du))/2, 1);
     u:=u+du;
   end;
  for i:=1 to Segm-1 do
   begin
    MeshBuilder.CreateFace(z);
    z.AddVertexAndNormalIndexed(v[i],n[i]);
    z.AddVertexAndNormalIndexed(v[0],n1[i]);
    z.AddVertexAndNormalIndexed(v[i+1],n[i+1]);
    MeshBuilder.AddFace(z);
    z:=nil;
   end;
  MeshBuilder.CreateFace(z);
  for i:=1 to Segm-1 do
    z.AddVertexAndNormalIndexed(v[i],n[0]);
  MeshBuilder.AddFace(z);
  z:=nil;
  MeshBuilder.SetPerspective(true);
end;

function GetNormal(vertex:tv;v1,v2,v3:integer):D3DVector;
var v:array[1..3] of D3DVector;
    z21,y12,q,a,s:double;
    fl:boolean;
begin
  fl:=true;
  v[1].x:=vertex[v2,1]-vertex[v1,1];
  v[1].y:=vertex[v2,2]-vertex[v1,2];
  v[1].z:=vertex[v2,3]-vertex[v1,3];
  v[2].x:=vertex[v3,1]-vertex[v1,1];
  v[2].y:=vertex[v3,2]-vertex[v1,2];
  v[2].z:=vertex[v3,3]-vertex[v1,3];
  if (v[1].x=0) and (v[2].x=0) then begin v[3].x:=1;v[3].y:=0;v[3].z:=0;fl:=false; end;
  if (v[1].y=0) and (v[2].y=0) then begin v[3].x:=0;v[3].y:=1;v[3].z:=0;fl:=false; end;
  if (v[1].z=0) and (v[2].z=0) then begin v[3].x:=0;v[3].y:=0;v[3].z:=1;fl:=false; end;
 if fl then
 begin
  if v[1].z<>0 then z21:=v[2].z/v[1].z else z21:=1E115;
  if v[2].y<>0 then y12:=v[1].y/v[2].y else y12:=1E115;
  a:=(v[2].y-(z21*v[1].y)); if a=0 then a:=1E115;
  s:=(v[1].z-(y12*v[2].z)); if s=0 then s:=1E115;
  q:=1+sqr((z21*v[1].x-v[2].x)/a)+sqr((y12*v[2].x-v[1].x)/s);
  v[3].x:=sqrt(1/q);
  v[3].y:=v[3].x*(z21*v[1].x-v[2].x)/a;
  v[3].z:=v[3].x*(y12*v[2].x-v[1].x)/s;
 end   ;
 Result:=v[3];
end;

procedure MoveVertex(dx,dy,dz:single;Mesh:IDirect3DRMMeshBuilder);
var v,n:array of TD3DVector;
    q:integer;
    a,w,e,nc:cardinal;
begin
  Mesh.GetVertices(a,v[0],nc,n[0],w,e);
  SetLength(v,a);
  SetLength(n,nc);
  Mesh.GetVertices(a,v[0],nc,n[0],w,e);
  for q:=0 to a-1 do
   begin
     v[q].x:=v[q].x+dx;
     v[q].y:=v[q].y+dy;
     v[q].z:=v[q].z+dz;
     Mesh.SetVertex(q,v[q].x,v[q].y,v[q].z);
   end;
end;

procedure MoveFrame(dx,dy,dz:single;Frame:IDirect3DRMFrame);
var pf:IDirect3DRMFrame;
    q:TD3DVector;
begin
  Frame.GetParent(pf);
  Frame.GetPosition(pf,q);
  Frame.SetPosition(pf,q.x+dx,q.y+dy,q.z+dz);
end;

end.

