unit Unit1;

interface

uses
  Windows,  A3D, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DXInput, DXClass, OpenGL, FormGL;

type
  TForm1 = class(TForm)
    DXI: TDXInput;
    DXTimer: TDXTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  TArea = record
    obj:byte;
    attr:integer;
  end;
 ttank = record
          body,turret,gun:TAbstract3DFrame;
          x,y,u1,u2:single;
         end;

const
  DM:TGLMaterial = (Ambient:(r:0.1;g:0.1;b:0.1;a:1);Diffuse:(r:0.5;g:0.5;b:0.5;a:1);Specular:(r:1;g:1;b:1;a:1);Emission:0.0;Shininess:20.0);
  shir = 3;
  dlin = 3;
  px = 50;
  py = 50;
  ne = 300;
  mash = 0.8;
  du = pi/96;
  maxskin = 1;
  maxdetails = 12;
  maxfaces = 36;
  Vertex:array[1..48,1..3] of single =
{1}    ((-3,+2,+2),       (-1,+2,+2),     (+1,+2,+2),       (+3,+2,+2),       (3,2,-2),
{6}     (1,+2,-2),        (-1,+2,-2),     (-3,+2,-2),       (-3,0,+3),        (-1,0,3),
{11}    (-1,0,+2),        (+1,0,2),       (1,0,+3),         (+3,0,+3),        (+3,0,-3),
{16}    (+1,0,-3),        (+1,0,-2),      (-1,0,-2),        (-1,0,-3),        (-3,0,-3),
{21}    (+1.5,+2,-1.5),   (-1.5,+2,-1.5), (-1.5,+2,+0.5),   (+1.5,+2,+0.5),   (+1.5,+4,-1.5),
{26}    (-1.5,+4,-1.5),   (-1.5,+4,+0.5), (+1.5,+4,+0.5),   (-1,+3.75,0),     (-1,+3.75,+0.75),
{31}    (-1,+3.5,+1),     (-1,+2.5,+1),   (-1,+2.25,+0.75), (-1,+2.25,0),     (+1,+3.75,0),
{36}    (+1,+3.75,+0.75), (+1,+3.5,+1),   (+1,+2.5,+1),     (+1,+2.25,+0.75), (+1,+2.25,0),
{41}    (-0.5,+3.5,+1),   (+0.5,+3.5,+1), (+0.5,+2.5,+1),   (-0.5,+2.5,+1),   (-0.5,+3.5,+3),
{46}    (+0.5,+3.5,+3),   (-0.5,+2.5,+3), (+0.5,+2.5,+3));
  faces:array[1..maxfaces,1..7] of integer = ((47,45,41,44,1,3,2),(45,46,42,41,1,3,3),(46,48,43,42,1,3,1),
  (48,47,44,43,1,3,7),(47,48,46,45,2,3,5),(29,30,36,35,3,3,3),(30,31,37,36,3,3,4),(31,32,43,41,3,3,5),
  (42,44,38,37,3,3,5),(32,33,39,38,3,3,6),(33,34,40,39,3,3,7),(31,30,33,32,3,3,2),(30,29,34,33,3,3,2),
  (36,37,38,39,3,3,1),(35,36,39,40,3,3,1),(29,35,40,34,3,3,9),(26,27,28,25,8,2,3),(22,26,25,21,5,2,9),
  (23,27,26,22,5,2,2),(24,28,27,23,4,2,5),(21,25,28,24,5,2,1),(8,1,2,7,10,1,3),(6,3,4,5,10,1,3),
  (7,2,3,6,9,1,3),(1,9,10,2,11,1,12),(3,13,14,4,11,1,12),(20,8,7,19,11,1,11),(16,6,5,15,11,1,11),
  (9,1,8,20,3,1,1),(15,5,4,14,3,1,2),(19,7,18,18,3,1,2),(17,6,16,16,3,1,1),(11,2,10,10,3,1,2),
  (13,3,12,12,3,1,1),(18,7,6,17,12,1,9),(12,3,2,11,12,1,5));
  normals:array[1..12,1..3] of single = ((1,0,0),(-1,0,0),(0,1,0),(0,1,1),(0,0,1),(0,-1,1),(0,-1,0),(0,-1,-1),(0,0,-1),(0,1,-1),(0,2,-1),(0,2,1));

var
  Form1: TForm1;
  m:boolean = true;
  Main:TAbstract3D;
  bf, TexFr: TAbstract3DFrame;
  tank:array[1..1] of TTank;
  map:array[0..px+1,0..py+1] of TArea;
  ug,camx,camy,camz,camox,camoy,camoz:single;
  invm:integer = -1;
  capt:string;
  pau,mat:integer;


implementation

{$R *.DFM}

function CreateMain(const Form:Pointer;const Rect:PRect):Pointer;external '..\pz3d-2\pz3d_gldrv.dll';
function CreateFrame(const Parent:Pointer):Pointer;external '..\pz3d-2\pz3d_gldrv.dll';

function CreateTank(x,y,z:single;Index:integer):TAbstract3DFrame;
var
  mb,t:TAbstract3DFrame;
  a:array[0..3] of TFVN;
  n,q:integer;
begin
  mb:=CreateFrame(nil);
  tank[index].Body:=CreateFrame(mb);
  tank[index].Gun:=CreateFrame(mb);
  tank[index].Turret:=CreateFrame(mb);
  { }
  for q:=1 to maxfaces do
   begin
    t:=CreateFrame(tank[index].Body);
//    t.AntiAliasing:=True;
    n:=t.AddNormal(normals[faces[q,7],1],normals[faces[q,7],2],normals[faces[q,7],3]);
    a[0].Vertex:=t.AddVertex(vertex[faces[q,1],1],vertex[faces[q,1],2],vertex[faces[q,1],3]);
    a[0].Normal:=n;
    a[0].TexX:=1;
    a[0].TexY:=1;
    a[1].Vertex:=t.AddVertex(vertex[faces[q,2],1],vertex[faces[q,2],2],vertex[faces[q,2],3]);
    a[1].Normal:=n;
    a[1].TexX:=1;
    a[1].TexY:=0;
    a[2].Vertex:=t.AddVertex(vertex[faces[q,3],1],vertex[faces[q,3],2],vertex[faces[q,3],3]);
    a[2].Normal:=n;
    a[2].TexX:=0;
    a[2].TexY:=0;
    a[3].Vertex:=t.AddVertex(vertex[faces[q,4],1],vertex[faces[q,4],2],vertex[faces[q,4],3]);
    a[3].Normal:=n;
    a[3].TexX:=0;
    a[3].TexY:=1;
    t.AddFace(a);


//    mb.Scale(mash*0.5,mash*0.5,mash*0.5);
   end;


  tank[index].body.SetPosition(x,y,z);
  tank[index].gun.SetPosition(x,y,z);
  tank[index].turret.SetPosition(x,y,z);
  Result:=mb;
end;

procedure TForm1.FormCreate(Sender: TObject);
const pos1:TVector = (x:-4;y:30;z:-50);
 pos2:TVector = (x:40;y:30;z:50);
 dir : TVector = (x:0.0; y:0.0; z:0.0);
 amb : TGLColor = (r:0.1; g:0.1; b:0.1; a:1.0);
 diff : TGLColor = (r:0.9; g:0.9; b:0.9; a:1.0);
 spec : TGLColor = (r:0.9; g:0.9; b:0.9; a:1.0);

 me = 20;
 mt = 7;
var q:array[1..4] of TFVN;
    w:TGLMaterial;
    z:TAbstract3DFrame;
//    i:integer;
    zz:TRect;
begin
  zz:=ClientRect;
  Main:=TAbstract3D(CreateMain(Self,@zz));
  Main.Initialize;
//  for i:=1 to me do main.Scene.AddFrame(CreateElka(Random(px*2)-px,0,Random(py*2)-py));
//  for i:=1 to mt do main.Scene.AddFrame(CreateTank(Random(px*2)-px,0,Random(py*2)-py,1));
  Main.Ugol:=50;
{  l.Enabled:=True;
  l.Position:=pos1;
  l.Direction:=dir;
  l.Ambient:=amb;
  l.Diffuse:=diff;
  l.Specular:=spec;
  mvp.AddLight(l);
  l.Enabled:=True;
  l.Position:=pos2;
  l.Direction:=dir;
  l.Ambient:=amb;
  l.Diffuse:=diff;
  l.Specular:=spec;
  mvp.AddLight(l); }
  camx:=-10;
  camy:=7;
  camz:=10;
  ug:=-pi/4;

  w:=DefaultMaterial;
  w.Diffuse.r:=0.2;
  w.Diffuse.g:=0.2;
  w.Diffuse.b:=0.2;
  z:=main.scene;
  mat:=z.AddMaterial(dm);
  q[1].Vertex:=z.AddVertex(-50,0,-50);
  q[1].Normal:=z.AddNormal(0,1,0);
  q[1].TexX:=1;
  q[1].TexY:=1;
  q[1].Material:=mat;
  q[2].Vertex:=z.AddVertex(-50,0,50);
  q[2].Normal:=q[1].Normal;
  q[2].TexX:=1;
  q[2].TexY:=0;
  q[2].Material:=mat;
  q[3].Vertex:=z.AddVertex(50,0,50);
  q[3].Normal:=q[1].Normal;
  q[3].TexX:=0;
  q[3].TexY:=0;
  q[3].Material:=mat;
  q[4].Vertex:=z.AddVertex(50,0,-50);
  q[4].Normal:=q[1].Normal;
  q[4].TexX:=0;
  q[4].TexY:=1;
  q[4].Material:=mat;
  z.AddFace(q);
//  Caption:=glGetString(GL_RENDERER);
  DXTimer.Enabled:=True;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Main.ViewRect:=ClientRect;
end;

procedure TForm1.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
  if not Main.CanDraw then Exit;
  DXI.Update;
  capt:='';
//  capt:=copy(FloatToStr(camx),0,4)+'  '+copy(FloatToStr(camy),0,4)+'  '+copy(FloatToStr(camz),0,4) +
//  '  '+copy(FloatToStr(camox),0,4)+'  '+copy(FloatToStr(camoy),0,4)+'  '+copy(FloatToStr(camoz),0,4);
  if invm>0 then capt:=capt+' Inverted'
            else capt:=capt+' Normal';
  if isLeft in DXI.Keyboard.States then ug:=ug+du;
  if isRight in DXI.Keyboard.States then ug:=ug-du;
  if isButton4 in DXI.Keyboard.States then camy:=camy+1;
  if isButton3 in DXI.Keyboard.States then camy:=camy-1;
  if isButton5 in DXI.Keyboard.States then camoy:=camoy+0.025;
  if isButton6 in DXI.Keyboard.States then camoy:=camoy-0.025;
  camoy:=camoy+invm*DXI.Mouse.Y/200;
//  if camoy-camy>1 then camoy:=1+camy;
//  if camoy-camy<-1 then camoy:=-1+camy;
  if camy<-2 then camy:=-2;
  if camy>30 then camy:=30;
  ug:=ug+DXI.Mouse.X/100;
  while ug>2*pi do ug:=ug-2*pi;
  while ug<0 do ug:=ug+2*pi;
  camox:=cos(ug);
  camoz:=sin(ug);
  if isButton2 in DXI.Keyboard.States then
   begin
    camx:=camx-camoz; camz:=camz+camox;
   end;
  if isButton1 in DXI.Keyboard.States then
   begin
    camx:=camx+camoz; camz:=camz-camox;
   end;
  if pau>0 then dec(pau);
  if (isButton32 in DXI.Keyboard.States) and (pau=0) then
   begin
    invm:=-invm;
    pau:=3;
   end;
  if isUp in DXI.Keyboard.States then
   begin
    camx:=camx+camox;
    camz:=camz+camoz;
   end;
  if isDown in DXI.Keyboard.States then
   begin
    camx:=camx-camox;
    camz:=camz-camoz;
   end;

  Main.SetCameraPos(camx, camy, camz, camox+camx, camoy+camy, camoz+camz, 0.0, 1, 0.0);

  capt:=capt+'  FPS:'+inttostr(DXTimer.FrameRate)+'  '+Main.Renderer;
  form1.Caption:=capt;
  Main.Render;
end;

procedure TForm1.FormDestroy(Sender: TObject);
//var i,j:integer;
begin
{  ElkaSkin.Destroy;
  for i:=1 to MaxSkin do
   for j:=1 to MaxDetails do
    if Assigned(textskins[i,j]) then textskins[i,j].Destroy;}
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=13) and (ssAlt in Shift) then
   if WindowState=wsMaximized then begin WindowState:=wsNormal; BorderStyle:=bsSizeable end
   else begin WindowState:=wsMaximized;BorderStyle:=bsNone; end;
end;

end.
