unit Unit2;

interface

uses
  DXClass, DXDraws, DirectX, DXInput, SysUtils, Forms;


const
  shir = 3;
  dlin = 3;
  px = 30;
  py = 30;
  ne = 70;
  mash = 0.8;
  du = pi/96;
  maxskin = 1;
  maxdetails = 12;
  maxfaces = 36;
  Vertex:array[1..48,1..3] of single =
{1}    ((-3,+2,+2),       (-1,+2,+2),     (+1,+2,+2),       (+3,+2,+2),       (3,2,-2),
{6}     (1,+2,-2),        (-1,+2,-2),     (-3,+2,-2),       (-3,0,+3),        (-1,0,3),
{11}    (-1,0,+2),        (+1,0,2),       (1,0,+3),         (+3,0,+3),        (+3,0,-3),
{16}    (+1,0,-3),        (+1,0,-2),      (-1,0,-2),        (-1,0,-3),        (-3,0,-3),
{21}    (+1.5,+2,-1.5),   (-1.5,+2,-1.5), (-1.5,+2,+0.5),   (+1.5,+2,+0.5),   (+1.5,+4,-1.5),
{26}    (-1.5,+4,-1.5),   (-1.5,+4,+0.5), (+1.5,+4,+0.5),   (-1,+0.75,0),     (-1,+0.75,+0.75),
{31}    (-1,+0.5,+1),     (-1,-0.5,+1),   (-1,-0.75,+0.75), (-1,-0.75,0),     (+1,+0.75,0),
{36}    (+1,+0.75,+0.75), (+1,+0.5,+1),   (+1,-0.5,+1),     (+1,-0.75,+0.75), (+1,-0.75,0),
{41}    (-0.5,+0.5,+1),   (+0.5,+0.5,+1), (+0.5,-0.5,+1),   (-0.5,-0.5,+1),   (-0.5,+0.5,+3),
{46}    (+0.5,+0.5,+3),   (-0.5,-0.5,+3), (+0.5,-0.5,+3));
  faces:array[1..maxfaces,1..7] of integer = ((47,45,41,44,1,3,2),(45,46,42,41,1,3,3),(46,48,43,42,1,3,1),
  (48,47,44,43,1,3,7),(47,48,46,45,2,3,5),(29,30,36,35,3,3,3),(30,31,37,36,3,3,4),(31,32,43,41,3,3,5),
  (42,44,38,37,3,3,5),(32,33,39,38,3,3,6),(33,34,40,39,3,3,7),(31,30,33,32,3,3,2),(30,29,34,33,3,3,2),
  (36,37,38,39,3,3,1),(35,36,39,40,3,3,1),(29,35,40,34,3,3,9),(26,27,28,25,8,2,3),(22,26,25,21,5,2,9),
  (23,27,26,22,5,2,2),(24,28,27,23,4,2,5),(21,25,28,24,5,2,1),(8,1,2,7,10,1,3),(6,3,4,5,10,1,3),
  (7,2,3,6,9,1,3),(1,9,10,2,11,1,12),(3,13,14,4,11,1,12),(20,8,7,19,11,1,11),(16,6,5,15,11,1,11),
  (9,1,8,20,3,1,1),(15,5,4,14,3,1,2),(19,7,18,18,3,1,2),(17,6,16,16,3,1,1),(11,2,10,10,3,1,2),
  (13,3,12,12,3,1,1),(18,7,6,17,12,1,9),(12,3,2,11,12,1,5));
  normals:array[1..12,1..3] of single = ((1,0,0),(-1,0,0),(0,1,0),(0,1,1),(0,0,1),(0,-1,1),(0,-1,0),(0,-1,-1),(0,0,-1),(0,1,-1),(0,2,-1),(0,2,1));

var
  m:boolean = true;
  bf: IDirect3DRMFrame;
  t:array[1..10] of IDirect3DRMTexture;
  TextSkins : array[1..maxskin,1..maxdetails] of IDirect3DRMTexture;

procedure loadskins; forward;
procedure CreateElka(x,y,z:single;fr:IDirect3DRMFrame); forward;
procedure CreateTank(x,y,z:single;Index:integer;fr:IDirect3DRMFrame); forward;
procedure CreateTrava(x,y,z:single;fr:IDirect3DRMFrame); forward;

implementation

uses unit1;

procedure loadskins;
 var
  q,w:integer;
  qs,ws,ps:string;
 begin
  ps:=ExtractFilePath(application.ExeName);
  for q:=1 to maxskin do
   for w:=1 to maxdetails do
    begin
     qs:=inttostr(q);
     ws:=inttostr(w);
     if length(qs)<2 then qs:='0'+qs;
     if length(ws)<2 then ws:='0'+ws;
     form1.DXDraw.D3DRM.LoadTexture(PChar(ps+'\t'+qs+ws+'.bmp'),textskins[q,w]);
    end;
 end;

function GetNormal(x1,y1,z1,x2,y2,z2,x3,y3,z3:single):D3DVector;
var v:array[1..3] of D3DVector;
    z21,y12,q,a,s:double;
    fl:boolean;
begin
  fl:=true;
  v[1].x:=x2-x1;
  v[1].y:=y2-y1;
  v[1].z:=z3-z1;
  v[2].x:=x3-x1;
  v[2].y:=y3-y1;
  v[2].z:=z3-z1;
  if (v[1].x=0) and (v[2].x=0) then begin v[3].x:=1;v[3].y:=0;v[3].z:=0;fl:=false; end;
  if (v[1].y=0) and (v[2].y=0) then begin v[3].x:=0;v[3].y:=1;v[3].z:=0;fl:=false; end;
  if (v[1].z=0) and (v[2].z=0) then begin v[3].x:=0;v[3].y:=0;v[3].z:=1;fl:=false; end;
 if fl then
 begin
  if v[1].z<>0 then z21:=v[2].z/v[1].z else z21:=1E115;
  if v[2].y<>0 then y12:=v[1].y/v[2].y else y12:=1E115;
  a:=(v[2].y-(z21*v[1].y)); if a=0 then a:=1E115;
  s:=(v[1].z-(y12*v[2].z)); if s=0 then s:=1E115;
  q:=1+sqr((z21*v[1].x-v[2].x)/a)+sqr((y12*v[2].x-v[1].x)/s);
  v[3].x:=sqrt(1/q);
  v[3].y:=v[3].x*(z21*v[1].x-v[2].x)/a;
  v[3].z:=v[3].x*(y12*v[2].x-v[1].x)/s;
 end   ;
 Result:=v[3];
end;

procedure CreateTank(x,y,z:single;Index:integer;fr:IDirect3DRMFrame);
var
  w:IDirect3DRMWrap;
  a:IDirect3DRMFace;
  mb:IDirect3DRMMeshBuilder;
  d,s:single;
  n,q:integer;
  l1,l2:single;
  v:D3DVector;
// doubl:boolean;
begin
  form1.DXDraw.D3DRM.CreateFrame(fr,tank[index].Body);
  form1.DXDraw.D3DRM.CreateFrame(fr,tank[index].Gun);
  form1.DXDraw.D3DRM.CreateFrame(fr,tank[index].Turret);
  { }
  for q:=1 to maxfaces do
   begin
    form1.DXDraw.D3DRM.CreateMeshBuilder(mb);
    mb.CreateFace(a);
{    doubl:=false;
    if faces[q,5]<3 then
     begin
      doubl:=true;
      n:=mb.AddNormal(-normals[faces[q,7],1],-normals[faces[q,7],2],-normals[faces[q,7],3]);
      a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,4],1],vertex[faces[q,4],2],vertex[faces[q,4],3]),n);
      a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,3],1],vertex[faces[q,3],2],vertex[faces[q,3],3]),n);
      a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,2],1],vertex[faces[q,2],2],vertex[faces[q,2],3]),n);
      a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,1],1],vertex[faces[q,1],2],vertex[faces[q,1],3]),n);
      a.SetColorRGB(1,1,1);
      mb.AddFace(a);
      mb.SetTexture(TextSkins[1,faces[q,5]]);
      TextSkins[1,faces[q,5]].GetDecalSize(d,s);
      if doubl then
       begin
        TextSkins[1,faces[q,5]].SetDecalTransparency(true);
        TextSkins[1,faces[q,5]].SetDecalTransparentColor(0);
       end;
      l1:=sqrt(sqr(vertex[faces[q,2],1]-vertex[faces[q,1],1])+sqr(vertex[faces[q,2],2]-vertex[faces[q,1],2])+sqr(vertex[faces[q,2],3]-vertex[faces[q,1],3]));
      l2:=sqrt(sqr(vertex[faces[q,4],1]-vertex[faces[q,1],1])+sqr(vertex[faces[q,4],2]-vertex[faces[q,1],2])+sqr(vertex[faces[q,4],3]-vertex[faces[q,1],3]));
      if l1=0 then l1:=1;
      if l2=0 then l2:=1;
      form1.DXDraw.D3DRM.CreateWrap(D3DRMWRAP_flat,nil,
                                vertex[faces[q,1],1],vertex[faces[q,1],2],vertex[faces[q,1],3],
                                -normals[faces[q,7],1],-normals[faces[q,7],2],-normals[faces[q,7],3],
                                vertex[faces[q,2],1]-vertex[faces[q,1],1],vertex[faces[q,2],2]-vertex[faces[q,1],2],vertex[faces[q,2],3]-vertex[faces[q,1],3],
                                0,0,
                                d/l2,s/l1,w);
      w.Apply(mb);
     end;}

    v:=GetNormal(vertex[faces[q,1],1],vertex[faces[q,1],2],vertex[faces[q,1],3],
                 vertex[faces[q,2],1],vertex[faces[q,2],2],vertex[faces[q,2],3],
                 vertex[faces[q,3],1],vertex[faces[q,3],2],vertex[faces[q,3],3]);
//    n:=mb.AddNormal(normals[faces[q,7],1],normals[faces[q,7],2],normals[faces[q,7],3]);
    n:=mb.AddNormal(v.x,v.y,v.z);
    a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,1],1],vertex[faces[q,1],2],vertex[faces[q,1],3]),n);
    a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,2],1],vertex[faces[q,2],2],vertex[faces[q,2],3]),n);
    a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,3],1],vertex[faces[q,3],2],vertex[faces[q,3],3]),n);
    a.AddVertexAndNormalIndexed(mb.AddVertex(vertex[faces[q,4],1],vertex[faces[q,4],2],vertex[faces[q,4],3]),n);
    a.SetColorRGB(1,1,1);
    mb.AddFace(a);
    if faces[q][5]>0 then
     begin
      mb.SetTexture(TextSkins[1,faces[q,5]]);
      TextSkins[1,faces[q,5]].GetDecalSize(d,s);
{      if doubl then
       begin
        TextSkins[1,faces[q,5]].SetDecalTransparency(true);
        TextSkins[1,faces[q,5]].SetDecalTransparentColor(0);
       end;}
      l1:=sqrt(sqr(vertex[faces[q,2],1]-vertex[faces[q,1],1])+sqr(vertex[faces[q,2],2]-vertex[faces[q,1],2])+sqr(vertex[faces[q,2],3]-vertex[faces[q,1],3]));
      l2:=sqrt(sqr(vertex[faces[q,4],1]-vertex[faces[q,1],1])+sqr(vertex[faces[q,4],2]-vertex[faces[q,1],2])+sqr(vertex[faces[q,4],3]-vertex[faces[q,1],3]));
      if l1=0 then l1:=1;
      if l2=0 then l2:=1;
      form1.DXDraw.D3DRM.CreateWrap(D3DRMWRAP_flat,nil,
                                vertex[faces[q,1],1],vertex[faces[q,1],2],vertex[faces[q,1],3],
                                -normals[faces[q,7],1],-normals[faces[q,7],2],-normals[faces[q,7],3],
                                vertex[faces[q,2],1]-vertex[faces[q,1],1],vertex[faces[q,2],2]-vertex[faces[q,1],2],vertex[faces[q,2],3]-vertex[faces[q,1],3],
                                0,0,
                                d/l2,s/l1,w);
      w.Apply(mb);
     end;
    mb.Scale(mash*0.5,mash*0.5,mash*0.5);
    mb.SetPerspective(true);
    if faces[q][6]=3 then tank[index].Gun.AddVisual(mb);
    if faces[q][6]=2 then tank[index].Turret.AddVisual(mb);
    if faces[q][6]=1 then tank[index].body.AddVisual(mb);
   end;
  tank[index].body.SetPosition(fr,x,y,z);
  tank[index].gun.SetPosition(fr,x,y+1.5*mash,z);
  tank[index].turret.SetPosition(fr,x,y,z);
  fr.AddVisual(tank[index].body);
  fr.AddVisual(tank[index].gun);
  fr.AddVisual(tank[index].turret);
end;

procedure CreateTrava(x,y,z:single;fr:IDirect3DRMFrame);
 var
  v:array[0..4] of integer;
  n,q:integer;
  a:IDirect3DRMFace;
  mb:IDirect3DRMMeshBuilder;
 w:IDirect3DRMWrap;
 d,s:single;
 const
  obhod : array[1..4,1..2] of shortint = ((-1,-1),(-1,1),(1,1),(1,-1));
 begin
  form1.DXDraw.D3DRM.CreateMeshBuilder(mb);
  for q:=1 to 4 do v[q]:=mb.AddVertex(x+obhod[q,1]*shir,y,z+obhod[q,2]*dlin);
  n:=mb.AddNormal(0,1,0);
  mb.CreateFace(a);
  for q:=1 to 4 do a.AddVertexAndNormalIndexed(v[q],n);
  mb.AddFace(a);
  a.SetColorRGB(0,1,0);
  mb.SetPerspective(true);
  mb.SetTexture(t[1]);
  t[1].GetDecalSize(d,s);
  form1.DXDraw.D3DRM.CreateWrap(D3DRMWRAP_FLAT,fr,
                                x-shir, y, z-dlin,
                                0,-1, 0,
                                1, 0, 0,
                                0,0,
                                d/(2*dlin),s/(2*shir),w);
  w.Apply(mb);
  mb.Scale(mash,mash,mash);

  fr.AddVisual(mb);
 end;

procedure CreateElka(x,y,z:single;fr:IDirect3DRMFrame);
const vc=16;
      Rad=2;
      Rad1=0.5;
      h1 = 7;
      h2 = 2;
var
 v,n,n1:array[0..2*vc+1] of integer;
 u,du:double;
 d,s:single;
 a:IDirect3DRMFace;
 i:integer;
 mb:array[1..2] of IDirect3DRMMeshBuilder;
 w:array[1..2] of IDirect3DRMWrap;
begin
  form1.DXDraw.D3DRM.CreateMeshBuilder(mb[1]);
  form1.DXDraw.D3DRM.CreateMeshBuilder(mb[2]);
  u:=0;
  du:=2*pi/(vc-1);
  v[0]:=mb[1].AddVertex(x,h1+y,z);
  n[vc+1]:=mb[1].Addnormal(0,-1,0);
  for i:=1 to vc do
   begin
     v[i]:=mb[1].AddVertex(cos(u)*rad+x,y+h2,sin(u)*Rad+z);
     n[i]:=mb[1].AddNormal(cos(u),y+h2,sin(u));
     n1[i]:=mb[1].AddNormal((cos(u)+cos(u+du))/2,y+h1-h2,(sin(u)+sin(u+du))/2);
     u:=u+du;
   end;
  for i:=1 to vc-1 do
  begin
    mb[1].CreateFace(a);
    a.AddVertexAndNormalIndexed(v[i],n[i]);
    a.AddVertexAndNormalIndexed(v[0],n1[i]);
    a.AddVertexAndNormalIndexed(v[i+1],n[i+1]);
    mb[1].AddFace(a);
  end;
  mb[1].CreateFace(a);
  for i:=1 to vc-1 do
  begin
    a.AddVertexAndNormalIndexed(v[i],n[vc+1]);
  end;
  mb[1].AddFace(a);

  for i:=1 to vc do
   begin
     v[i]:=mb[2].AddVertex(cos(u)*rad1+x,y+h2,sin(u)*Rad1+z);
     n[i]:=mb[2].AddNormal(cos(u),y+h2,sin(u));
     v[i+vc]:=mb[2].AddVertex(cos(u)*rad1+x,y,sin(u)*Rad1+z);
     u:=u+du;
   end;
  for i:=1 to vc-1 do
  begin
    mb[2].CreateFace(a);
    a.AddVertexAndNormalIndexed(v[i],n[i]);
    a.AddVertexAndNormalIndexed(v[i+1],n[i+1]);
    a.AddVertexAndNormalIndexed(v[i+1+vc],n[i+1]);
    a.AddVertexAndNormalIndexed(v[i+vc],n[i+1]);
    mb[2].AddFace(a);
  end;
//  mb.Scale(0.3+0.5*Random,0.3+0.5*Random,0.3+0.5*Random);

  mb[1].SetTexture(t[2]);
  t[2].GetDecalSize(d,s);
  t[2].SetDecalTransparency(true);
  t[2].SetDecalTransparentColor(0);
  form1.DXDraw.D3DRM.CreateWrap(D3DRMWRAP_flat,fr,
                                x, y, z,
                                0, 1, 0,
                                1, 0, 0,
                                0,0,
                                d,s,w[1]);
  w[1].Apply(mb[1]);

  mb[2].SetTexture(t[3]);
  t[3].GetDecalSize(d,s);
  t[3].SetDecalTransparency(true);
  t[3].SetDecalTransparentColor(0);
  form1.DXDraw.D3DRM.CreateWrap(D3DRMWRAP_cylinder,fr,
                                x, y, z,
                                0, 1, 0,
                                0, 1, 0,
                                0,0,
                                d,s,w[2]);
  w[2].Apply(mb[2]);

  mb[1].Scale(mash,mash,mash);
  mb[1].SetPerspective(true);

  mb[2].Scale(mash,mash,mash);
  mb[2].SetPerspective(true);

  fr.AddVisual(mb[1]);
  fr.AddVisual(mb[2]);
end;


end.
