unit unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DXClass, DXDraws, DirectX;

type
  TForm1 = class(TDXForm)
    DXTimer: TDXTimer;
    DXDraw: TDXDraw;
    procedure DXDrawInitialize(Sender: TObject);
    procedure DXDrawFinalize(Sender: TObject);
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DXDrawClick(Sender: TObject);
    procedure DXDrawInitializeSurface(Sender: TObject);
  end;

var
  Form1: TForm1;
  m:boolean = true;

implementation

{$R *.DFM}

procedure TForm1.DXDrawInitialize(Sender: TObject);
var
  LightFrame, MeshFrame: IDirect3DRMFrame;
  Light, AmbientLight: IDirect3DRMLight;
  MeshBuilder: IDirect3DRMMeshBuilder;
  mb:array[1..5] of IDirect3DRMMeshBuilder;
  t:array[1..5] of IDirect3DRMTexture;
  z:IDirect3DRMFace;
  i:integer;
  w:array[1..5] of IDirect3DRMWrap;
  v,n:array[0..100] of integer;
  a,s:single;
begin
  {  Frame making  }
  DXDraw.D3DRM.CreateFrame(DXDraw.Scene , LightFrame);
  DXDraw.D3DRM.CreateFrame(DXDraw.Scene, MeshFrame);
  {  Light setting  }
  DXDraw.D3DRM.CreateLightRGB(D3DRMLIGHT_point, 2, 2, 2, Light);
  LightFrame.AddLight(Light);

  DXDraw.D3DRM.CreateLightRGB(D3DRMLIGHT_AMBIENT, 0.1, 0.1, 0.1, AmbientLight);
  DXDraw.Scene.AddLight(AmbientLight);

  {  Frame position and posture setting  }
  LightFrame.SetPosition(DXDraw.Scene, 4, 10.0, -10);
  DXDraw.Camera.SetPosition(DXDraw.Scene, -5.0, 10.0, 0.0);
  DXDraw.Camera.SetOrientation(DXDraw.Scene, 0.35, -0.65, 1.0, -0.15, 1.0, 0.5);

  MeshFrame.SetPosition(DXDraw.Scene, 0.0, 0.0, 15);
  MeshFrame.SetOrientation(DXDraw.Scene, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0);
  MeshFrame.SetRotation(DXDraw.Scene, 0.0, 1.0, 0.0, 0.05);

  {  Mesh making  }

  for i:=1 to 5 do
   DXDraw.D3DRM.LoadTexture(PChar(IntToStr(i)+'.bmp'),t[i]);

  DXDraw.D3DRM.CreateMeshBuilder(MeshBuilder);
  for i:=1 to 5 do DXDraw.D3DRM.CreateMeshBuilder(MB[i]);
  v[1]:=MeshBuilder.AddVertex(-1,-1,-1);
  v[2]:=MeshBuilder.AddVertex(-1, 1,-1);
  v[3]:=MeshBuilder.AddVertex( 1, 1,-1);
  v[4]:=MeshBuilder.AddVertex( 1,-1,-1);
  v[5]:=MeshBuilder.AddVertex(-1,-1, 1);
  v[6]:=MeshBuilder.AddVertex(-1, 1, 1);
  v[7]:=MeshBuilder.AddVertex( 1, 1, 1);
  v[8]:=MeshBuilder.AddVertex( 1,-1, 1);
  n[1]:=MeshBuilder.AddNormal( 0, 0,-1);
  n[2]:=MeshBuilder.AddNormal( 1, 0, 0);
  n[3]:=MeshBuilder.AddNormal( 0, 0, 1);
  n[4]:=MeshBuilder.AddNormal(-1, 0, 0);
  n[5]:=MeshBuilder.AddNormal( 0, 1, 0);

  for i:=1 to 5 do MB[i].AddMeshBuilder(MeshBuilder);

  {Ivan}
  MB[1].CreateFace(z);
  z.AddVertexAndNormalIndexed(v[1],n[1]);
  z.AddVertexAndNormalIndexed(v[2],n[1]);
  z.AddVertexAndNormalIndexed(v[3],n[1]);
  z.AddVertexAndNormalIndexed(v[4],n[1]);
  MB[1].AddFace(z);
  z.SetTexture(t[1]);
  t[1].GetDecalSize(a,s);
  DXDraw.D3DRM.CreateWrap(D3DRMWRAP_FLAT,nil,
                         -1,-1,0,
                          0,0,1,
                          0,1,0,
                          0,0,
                          a/2,s/2,w[1]);
  w[1].Apply(z);
  {Mish!}
  MB[2].CreateFace(z);
  z.AddVertexAndNormalIndexed(v[3],n[2]);
  z.AddVertexAndNormalIndexed(v[7],n[2]);
  z.AddVertexAndNormalIndexed(v[8],n[2]);
  z.AddVertexAndNormalIndexed(v[4],n[2]);
  MB[2].AddFace(z);
  z.SetTexture(t[3]);
  t[3].GetDecalSize(a,s);
  DXDraw.D3DRM.CreateWrap(D3DRMWRAP_FLAT,nil,
                          0,-1,-1,
                         -1,0,0,
                          0,1,0,
                          0,0,
                          a/2,s/2,w[2]);
  w[2].Apply(z);
  {(C)HooP$}
  MB[3].CreateFace(z);
  z.AddVertexAndNormalIndexed(v[7],n[3]);
  z.AddVertexAndNormalIndexed(v[6],n[3]);
  z.AddVertexAndNormalIndexed(v[5],n[3]);
  z.AddVertexAndNormalIndexed(v[8],n[3]);
  MB[3].AddFace(z);
  z.SetTexture(t[2]);
  t[2].GetDecalSize(a,s);
  DXDraw.D3DRM.CreateWrap(D3DRMWRAP_FLAT,nil,
                          1,-1,1,
                          0,0,-1,
                          0,1,0,
                          0,0,
                          a/2,s/2,w[3]);
  w[3].Apply(z);
  {Atrides}
  MB[4].CreateFace(z);
  z.AddVertexAndNormalIndexed(v[6],n[4]);
  z.AddVertexAndNormalIndexed(v[2],n[4]);
  z.AddVertexAndNormalIndexed(v[1],n[4]);
  z.AddVertexAndNormalIndexed(v[5],n[4]);
  MB[4].AddFace(z);
  z.SetTexture(t[4]);
  t[4].GetDecalSize(a,s);
  DXDraw.D3DRM.CreateWrap(D3DRMWRAP_FLAT,nil,
                         -1,-1,1,
                          1,0,0,
                          0,1,0,
                          0,0,
                          a/2,s/2,w[4]);
  w[4].Apply(z);
  {Names}
  MB[5].CreateFace(z);
  z.AddVertexAndNormalIndexed(v[6],n[5]);
  z.AddVertexAndNormalIndexed(v[7],n[5]);
  z.AddVertexAndNormalIndexed(v[3],n[5]);
  z.AddVertexAndNormalIndexed(v[2],n[5]);
  MB[5].AddFace(z);
  z.SetTexture(t[5]);
  t[5].GetDecalSize(a,s);
  DXDraw.D3DRM.CreateWrap(D3DRMWRAP_FLAT,nil,
                         -1,1, 1,
                          0,-1,0,
                          1,0,0,
                          0,0,
                          a/2,s/2,w[5]);
  w[5].Apply(z);


  for i:=1 to 5 do
   begin
    MB[i].Scale(4, 4, 4);
    mb[i].SetPerspective(true);
    MeshFrame.AddVisual(MB[i]);
   end;

  DXDraw.D3DRMDevice.SetQuality(D3DRMRENDER_GOURAUD);
  DXTimer.Enabled := True;
end;

procedure TForm1.DXDrawFinalize(Sender: TObject);
begin
  DXTimer.Enabled := False;
end;

procedure TForm1.DXDrawInitializeSurface(Sender: TObject);
begin
  if doHardware in DXDraw.NowOptions then
  begin
    {  Bi-linear filtering  }
    DXDraw.D3DRMDevice.SetTextureQuality(D3DRMTEXTURE_LINEAR);
  end;
end;

procedure TForm1.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
  if not DXDraw.CanDraw then exit;

  DXDraw.Viewport.ForceUpdate(0, 0, DXDraw.SurfaceWidth, DXDraw.SurfaceHeight);

  if m then DXDraw.Scene.Move(0.6);
  DXDraw.Render;

  with DXDraw.Surface.Canvas do
  begin
    Brush.Style := bsClear;
    Font.Color := clWhite;
    Font.Size := 12;
    Textout(0, 0, 'FPS: '+inttostr(DXTimer.FrameRate));
    if doHardware in DXDraw.NowOptions then
      Textout(0, 14, 'Device: Hardware')
    else
      Textout(0, 14, 'Device: Software');
    if not m then Textout(0, 30, '[Paused]');
    Release; {  Indispensability  }
  end;

  DXDraw.Flip;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  m:=not m;
  {  Application end  }
  if Key=VK_ESCAPE then
    Close;

  {  Screen mode change  }
  if (ssAlt in Shift) and (Key=VK_RETURN) then
  begin
    DXDraw.Finalize;

    if doFullScreen in DXDraw.Options then
    begin
      RestoreWindow;

      DXDraw.Cursor := crDefault;
      BorderStyle := bsSizeable;
      DXDraw.Options := DXDraw.Options - [doFullScreen];
    end else
    begin
      StoreWindow;

      DXDraw.Cursor := crNone;
      BorderStyle := bsNone;
      DXDraw.Options := DXDraw.Options + [doFullScreen];
    end;

    DXDraw.Initialize;
  end;
end;

procedure TForm1.DXDrawClick(Sender: TObject);
begin
  m:=not m;
end;

end.

